plotpoints<-1
plotfittedcurve<-1
plottofile<-1
horizontalplots<-TRUE
plotalldata<-0
datanameintitle<-0
imagealltogether<-1
imagemeans<-0#decides whether to plot the means in the image plot
imageclusters<-0
blockpicture<-1
bicplot<-1
plotresiduals<-1
rawplot<-0
imageunordered<-1
rkbysig<-0
onepageplottofile<-0
plotsonsamescale<-1
extrarows<-12
homedir<-"./"
thisdir<-"./"
partic<-scan(paste(paste(homedir,thisdir,sep=""),"currentfile.txt",sep=""), what=character())
allys<-as.matrix(read.table(paste(paste(paste(homedir,thisdir,sep=""),partic,sep=""),".txt",sep="")))
numclust<-max(allys[,1])

if(plottofile)
{	
  psname<-paste(paste(paste(homedir,thisdir,sep=""),partic,sep=""),"_preds.ps",sep="")
  pdfname<-paste(paste(paste(homedir,thisdir,sep=""),partic,sep=""),"_preds.pdf",sep="")
  jpgname<-paste(paste(paste(homedir,thisdir,sep=""),partic,sep=""),"_preds.jpg",sep="")
#  postscript(psname,horizontal=horizontalplots)
  pdf(pdfname,width=12,height=10)#,horizontal=horizontalplots)
}
par(mfrow=c(1,1))
if(!plottofile || onepageplottofile)
{
  if( numclust < 4 )
  {
    par(mfrow=c(1,numclust))
  }
  else if( numclust == 4 )
  {
    par(mfrow=c(2,2))
  }
  else
  {
    rows <- ceiling(sqrt(numclust))-1
    cols <- floor(sqrt(numclust))+2
    cols <- ceiling(numclust/rows)
    par(mfrow=c(rows,cols))
  }
}

xs<-scan(paste(paste(paste(homedir,thisdir,sep=""),partic,sep=""),"_x.txt",sep=""))
lxs<-length(xs)
if( lxs == 1 ){
  lxs <- dim(allys)[2] - 1
  xs<-1:lxs
}
uxs<-unique(xs)
luxs<-length(uxs)
reps<-lxs/luxs
if(lxs > 2 ){
  xs2<-c(uxs,uxs[luxs]+2*(uxs[luxs]-uxs[luxs-1])-(uxs[luxs-1]-uxs[luxs-2]))
  for( i in 2:lxs ){
    xs2[i] <- ( uxs[ i-1 ] + uxs[ i ] ) / 2
  }
  xs2[ luxs+1 ] <- uxs[ luxs ]
  xs2<-c(xs2[1]-1,uxs)
}
xmax<-max(xs)
xmin<-min(xs)
xran<-xmax-xmin
if( numclust<= 40 ){ clusterlinesonimage<-1 }else{ clusterlinesonimage<-0 }
clusternumbersonimage <- numclust < 50
numallys<-dim(allys)[1]
biggesty<-max(allys[1:numallys,2:(lxs+1)])
smallesty<-min(allys[1:numallys,2:(lxs+1)])
grred <-c("green4","green3","green2","green1","green","darkgreen","black","darkred","red","red1","red2","red3","red4")
#library(sma)
#nrgcols<-50
#grred<-rgcolors.func(nrgcols)
grred<-c("#00FF00", "#00F400", "#00EA00", "#00DF00", "#00D400", "#00CA00", "#00BF00", "#00B500", "#00AA00", "#009F00", "#009500", "#008A00", "#008000", "#007500", "#006A00", "#006000", "#005500", "#004A00", "#004000", "#003500", "#002A00", "#002000", "#001500", "#000B00", "#000000", "#000000", "#0B0000", "#150000", "#200000", "#2A0000", "#350000", "#400000", "#4A0000", "#550000", "#600000", "#6A0000", "#750000", "#800000", "#8A0000", "#950000", "#9F0000", "#AA0000", "#B50000", "#BF0000", "#CA0000", "#D40000", "#DF0000", "#EA0000", "#F40000", "#FF0000")
#grred<-scan("grred.dat",what='char')


if(rawplot){
  numindices<-numallys
  indices<-seq(from=1,to=numindices,length=numindices)
#  set.seed(0)
#  numindices<-500
#  indices<-sample(numallys,numindices,replace=TRUE)
  plot(xs,allys[indices[1],2:(lxs+1)],ylim=c(smallesty,biggesty),col=1,xlab="Time",ylab="Expression",type='l',lty=3,lwd=.5)
  for( i in 1:numallys ){
    points(xs,allys[indices[i],2:(lxs+1)],pch=4)
    for( j in 0:(reps-1) ){
      start<-2+j*luxs
      end<-2+(j+1)*luxs-1
      lines(uxs,allys[indices[i],start:end],lty=3,lwd=1)
    }
  }
}

is<-seq(from=1,to=numclust,length=numclust)
#is<-c(2,3,5,6,1,4,7)
#is<-c(2,1)
#is<-c(18,20,14,19,21,25);par(mfrow=c(2,3))
ys<-NULL
startpoints<-seq(from=1,to=1,length=numclust+2)

ys2<-NULL
predsstore<-NULL
numsinclusters<-c(from=0,to=0,length=numclust)
for( ii in 1:length(is) )
{
	i <- is[ii]
        ydata2<-NULL
        for( j in 1:numallys ){
          if( allys[j,1] == i ){
            ydata2<-c(ydata2,allys[j,2:(lxs+1)])}
        }
#	ydata2<-scan(paste(paste(paste(paste(homedir,thisdir,sep=""),partic,sep=""),i,sep=""),".dat",sep=""))
	startpoints[ii+1]<-startpoints[ii]+length(ydata2)#/lxs
        ys2 <- c( ys2, ydata2 )
}
startpoints[length(is)+1] <- length(ys2)+1
#ys2<-allys[,2:(lxs+1)]
ysunranked<-ys2
ys2<-rank(ys2)
startpoints[length(is)+2] <- length(ys2)+1
smallesty2<-1
biggesty2<-length(ys2)

bigpreds<-matrix(scan(paste(paste(paste(paste(homedir,thisdir,sep=""),partic,sep=""),"_preds_",sep=""),".dat",sep="")), byrow=T, ncol=3)
predrows<-dim(bigpreds)[1]/numclust
preds<-matrix(nrow=predrows,ncol=3)
for( ii in 1:length(is) )
{
	i <- is[ii]
	numobs<-(startpoints[ii+1]-startpoints[ii])/lxs
        #numobs<-length(scan(paste(paste(paste(paste(homedir,thisdir,sep=""),partic,sep=""),i,sep=""),".dat",sep="")))/lxs
	numsinclusters[ i ] <- numobs
        for( j in 1:predrows ){
          preds[j,] <-bigpreds[(i-1)*predrows+j,]
        }
#	preds<-matrix(scan(paste(paste(paste(paste(paste(homedir,thisdir,sep=""),partic,sep=""),"_preds_",sep=""),i,sep=""),".dat",sep="")) , byrow=T,ncol=3)
	ymax <- 0
	if( numobs > 1 )
	{
		ymax<-max(preds)
		ymin<-min(preds)
	}
	if( numobs <= 1 || is.nan( ymax ) || is.nan( ymin ) )
	{
		ymax<-max(preds[,2])
		ymin<-min(preds[,2])
	}
	if(plotpoints)
	{
#		ydata<-scan(paste(paste(paste(paste(homedir,thisdir,sep=""),partic,sep=""),i,sep=""),".dat",sep=""))
		ydata<-ysunranked[startpoints[ii]:(startpoints[ii+1]-1)]
		ymx<-matrix(ydata,byrow=T,ncol=length(xs))
		ydata2i<-ys2[startpoints[ii]:(startpoints[ii+1]-1)]
		ymx2<-matrix(ydata2i,byrow=T,ncol=length(xs))
		ymax<-max(c(ymax,max(ymx)))
		ymin<-min(c(ymin,min(ymx)))
	}
#	   numpreds<-length(preds[,2])
        numpreds<-length(preds[seq(from=1,to=length(preds[,2]),length=lxs),2])
#             predsstore<-c(predsstore,preds[,2])
        predsstore<-c(predsstore,preds[seq(from=1,to=length(preds[,2]),length=lxs),2])
        nys <- length(ymx[,1])
        plotymin<-ymin; plotymax<-ymax
        plotxmin<-xmin; plotxmax<-xmax
	if( plotsonsamescale ){
          plotymin<-smallesty; plotymax<-biggesty
        }
        if( xmin == xmax ){ xs<-xs-min(xs); plotxmin<-0; plotxmax<-nys+1 }
        plot(NA,xlim=c(plotxmin,plotxmax),ylim=c(plotymin,plotymax),xlab="Time",ylab="Expression")
        lines(c(2*xmin-xmax,2*xmax-xmin),c(0,0))
	if( datanameintitle ) { titlei<-paste(partic,", ",sep="")}
	else { titlei<-"" }
	titlei<-paste(titlei, paste("Cluster ",i,sep=""),sep="")
#	if(ii<5){titlei<-"Anapholes"}else{titlei<-"Plasmodium"}
	title2i<-paste(' (', paste(numobs,' obsns.)',sep=""),sep="")
	title3i<-paste(titlei,title2i,sep="")
	title(title3i)
	if(plotpoints)
	{
		for( j in 1:nys )
                  {
                    points(xs,ymx[j,],pch=16,cex=.5,lty=3,col=1)
                    for( jj in 0:(reps-1) ){
                      start<-1+jj*luxs
                      end<-1+(jj+1)*luxs-1
                      lines(uxs,ymx[j,start:end],lty=3,lwd=1,col=1)
                    }
                  }
	}
	if( plotfittedcurve ){
	  if( numobs > 1 && !is.nan( max(preds[,1] ) ) || !is.nan(
	min(preds[,3]) ) )
	  {
	    lines(seq(from=xmin,to=xmax,length=length(preds[,1])),preds[,1],col=5,lwd=1)
            lines(seq(from=xmin,to=xmax,length=length(preds[,3])),preds[,3],col=5,lwd=1)
	  }
	  lines(seq(from=xmin,to=xmax,length=length(preds[,2])),preds[,2],col=4,lwd=3)
	}
	nys <- length(ymx2[,1])
	if( plotpoints ){
          ys <- c( ys, ydata )
          n <- 10
          if( nys > 1 ){
#		jpeg(jpgname)
#		image( seq(from=1,to=nys,length=nys), xs,ymx2,xlab='genes', ylab = 'time', col=grred,zlim=c(smallesty2,biggesty2) )
#		dev.off()

            if( imageclusters ){
		image( seq(from=1,to=nys,length=nys+1), xs2, ymx2,xlab='Genes', ylab = 'Time', col=grred, zlim=c(smallesty2,biggesty2) )
}
		
		#image( xs, seq(from=1,to=nys,length=nys), t(ymx), ylab='genes', xlab = 'time',col= heat.colors(12)))
	#rainbow(n,s = 1,v = 1,start =0+2/6,end=max(1,n - 1)/n*0,gamma = 1)
#"palegreen","palegreen1","palegreen2","palegreen3","palegreen4","palevioletred","palevioletred1","palevioletred2","palevioletred3","palevioletred4",
	}
        }
}

par(mfrow=c(1,1))

if( plotalldata ){
    plot( xs, allys[1,2:(lxs+1)],type='l',lty = 3,ylim=c(smallesty,biggesty) )
    for( j in 1: dim(allys)[1] ){
	lines(xs,allys[j,2:(lxs+1)],lty=3,lwd=.5)
	points(xs,allys[j,2:(lxs+1)],pch=4,lty=3,lwd=.5)
    }
}


if( imagealltogether )
{
  ysunordered<-scan(paste(paste(paste(homedir,thisdir,sep=""),partic,sep=""),".dat",sep=""))
  ysunordered<-rank(ysunordered)
  xs<-uxs
  numpreds<-lxs<-luxs
  ysunordered<-matrix(ysunordered,byrow=T,ncol=length(xs))
  nys <- length(ysunordered[,1])
  if( imageunordered ){
    image(seq(from=1,to=nys,length=nys+1),xs2,ysunordered,xlab='Genes',ylab='Time',col=grred)
  }
  ys2<-ysunordered
  dendorder<-scan(paste(paste(paste(homedir,thisdir,sep=""),partic,sep=""),"_dendro_output_.dat",sep=""))
  for( i in 1:dim(ys2)[1] ){
    ys2[i,] <- ysunordered[dendorder[i],]
  }
  nys <- length(ys2[,1])
  if(blockpicture){
    par(mfrow=c((3+rkbysig  - 2 ),1))
  }

if(blockpicture){
  predsstore <- matrix(predsstore,byrow=T,ncol=numpreds)
#*****rank the clusters in order of significance, for j=2 in next loop.
  if( rkbysig ){
  clsigs<-matrix(scan(paste(paste(paste(homedir,thisdir,sep=""),partic,sep=""),"_splitting_res.txt",sep="")),ncol=3,byrow=T)
  rk <- clsigs[,2]
  rk <- order(rk)
  }
#******
  for( j in 1:(1+rkbysig) )
  {
    for( ii in 1:numclust )
    {
       i<-ii
       if( j == 2 ){ i <- rk[ii] }
       if( ii == 1 ){
         predsstore2 <- predsstore[i,]
         if( reps > 1 ){
           for( iii in 2:reps ){
             predsstore2<-c( predsstore2, predsstore[i,] )
           }
         }
	 if( numsinclusters[i] > 1 ){
           for( iii in 1:((numsinclusters[i]-1)*reps) ){
	      predsstore2<-c( predsstore2, predsstore[i,] )
	   }
         }
       }
       else{
         for( iii in 1:(numsinclusters[i]*reps) ){
	    predsstore2<-c( predsstore2, predsstore[i,] )
         }     
       }
    }
    predsstore2<-rank(predsstore2)    
    predsstoremx <- matrix(predsstore2,byrow=T,ncol=numpreds)
    if( j == 1 ){ 
# image(seq(from=1,to=nys,length=nys),seq(from=1,to=max(xs),length=numpreds),predsstoremx,xlab='',ylab='time',col=grred)
    }
  }
  }
#  image(seq(from=1,to=nys,length=nys),xs,ys2,xlab='genes',ylab='time',col=grred)
  if( imagemeans ){
    imxs<-c(xs2,xs+maxxs2,2*maxxs2+seq(from=1,to=xran,length=extrarows))
    mx<-cbind(ys2,predsstoremx*max(ys2)/max(predsstoremx))
  }else{
    imxs<-c(c(xmin-1,xs),xmax+seq(from=1,to=xran,length=extrarows))
    mx<-ys2
  }
  mx<-cbind(mx,matrix(nrow=dim(mx)[1],ncol=extrarows))
  if( clusternumbersonimage ){
    imxs<-c(seq(from=-5,to=min(xs2)-1,length=5),imxs)
    mx<-cbind(matrix(nrow=dim(mx)[1],ncol=5),mx)
  }
#  xs<-seq(from=1,to=max(xs),length=length(xs))
  maxxs2<-max(xs2)
  if( xs2[1] < 0 ){ maxxs2<-maxxs2-xs2[1] }
  if( imagemeans ){
    image(seq(from=.5,to=nys+.5,length=nys+1),imxs,mx,tck=0,col.axis="white",xlab='',ylab='',col=grred,axes=FALSE)
    axis(side=2,at=xs2)
  }else{
    image(seq(from=.5,to=nys+.5,length=nys+1),imxs,mx,tck=0,col.axis="white",xlab='',ylab='',col=grred,axes=FALSE)
    axis(side=2,at=xs)
  }
  numclusttot<-0
  if( clusterlinesonimage ){
    for( i in 1:(numclust-1) )
      {
        oldnumclusttot<-numclusttot
        numclusttot<-numclusttot+numsinclusters[i]
        lines(c(numclusttot+.5,numclusttot+.5),c(-2.5+0*(max(xs2)+1),2*max(xs2)+.5*0),lwd=1.5,col="white")
                                        #     text((numclusttot+oldnumclusttot)/2,-3,paste(partic, paste(", Cluster ",i,sep=""),sep=""))
      }
  }
  numclusttot<-0
  if( clusternumbersonimage ){
    for( i in 1:(numclust) )
      {
        oldnumclusttot<-numclusttot
        numclusttot<-numclusttot+numsinclusters[i]
                                        #    lines(c(-1+0*(max(xs2)+1),2*max(xs2)+.5*0),c(numclusttot,numclusttot),lwd=2)
                                        #    lines(c(numclusttot,numclusttot),c(-1+0*(max(xs2)+1),2*max(xs2)+.5*0),lwd=2)
        numsteps<-2;#if(i>24){numsteps<-5}
        stepdown<-numsteps*((i-1)/numsteps-floor((i-1)/numsteps))
        text((numclusttot+oldnumclusttot)/2,xs2[1]-1-stepdown,paste("#",i,sep=""),cex=.8)
      }
  }else{
    axis(side=1)
  }
  if( reps == 1 ){
    startheight<-xmax
    if( imagemeans ){ startheight<-2*maxxs2 }
    source('s_dendrogram.R')
  }
if( blockpicture && rkbysig ){
  image(seq(from=1,to=nys,length=nys+1),seq(from=1,to=max(xs2),length=numpreds+1),predsstoremx,xlab='Genes',ylab='Time',col=grred)

}
  
}

if( bicplot ){
par(mfrow=c(1,1))
mergers<-matrix(scan(paste(paste(paste(homedir,thisdir,sep=""),partic,sep=""),"_mergerdetails_.dat",sep="")),byrow=T,ncol=7)
numrows<-dim(mergers)[1]
secondstartrow<-floor(numrows/2)+1
twocurves<-0
numinplot<-2*numclust
if( mergers[ secondstartrow ] ==  mergers[ 1 ] ){ twocurves <- 1 }
if( !twocurves ){
 startrow <- max(1,(numrows-numinplot))
 bic<-mergers[startrow:numrows,6]
 ncs<-mergers[startrow:numrows,1]
}else{
 startrow <- max(1,(secondstartrow-numinplot))
 startrow2 <- max(secondstartrow,(numrows-numinplot))
 bic<-c(mergers[startrow:secondstartrow-1,6],mergers[startrow2:numrows,6])
 ncs<-c(mergers[startrow:secondstartrow-1,1],mergers[startrow2:numrows,1])
}
#maxbic<-max(bic)
#bic<-exp(bic-maxbic)

if( twocurves ){
  secondstartrow<-length(bic)/2+1
  plot(ncs[1:(secondstartrow-1)],bic[1:(secondstartrow-1)],pch=16,cex=.5,xlab='Number of clusters (C)',ylab='Log marginal likelihood',ylim=c(min(bic),max(bic)))
  points(ncs[secondstartrow:(numrows-startrow+1)],bic[secondstartrow:(numrows-startrow+1)],pch=5,cex=.5,col='blue')
  lines(c(numclust,numclust),c(2*min(bic)-max(bic),bic[secondstartrow-1+numclust]),col='red',lty=2)
}else{
  plot(ncs,bic,pch=16,cex=.5,xlab='Number of clusters (C)',ylab='Log marginal likelihood')
}
  lines(c(numclust,numclust),c(2*min(bic)-max(bic),bic[ncs[numclust]]),col='red')
  text(numclust+numinplot/30,bic[ncs[numclust]]-(max(bic)-min(bic))/5,paste('C=',numclust),col='red')

}

if( plotresiduals ){
  Residuals <- scan(paste(paste(paste(homedir,thisdir,sep=""),partic,sep=""),"_residuals_.dat",sep=""))
  hist(Residuals,nclass=100,freq=F,col='purple')
  rs<-seq(min(Residuals),max(Residuals),length=100)
  lines(rs,dnorm(rs,mean(Residuals),sd(Residuals)))
}

if(plottofile)
{
  dev.off()
}

